program test2;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}
uses
  assoca, assocabase, sysutils{tylko dla inttostr};


// Nowa, wlasna klasa oparta na assoca
type
  TMyAssoc = class(TCustomAssocArray)
  private
    FCos: string;
  
    FValue: Integer;
    function GetItem(AName: Integer): TMyAssoc; reintroduce;
  public
    constructor Create;
    
    procedure Print; // jakas przykladowa, dodatkowa procedura..
    property Info: string read FCos write FCos; // dodatkowe pole..
    
    property Items[const AName: Integer]: TMyAssoc read GetItem; default;
    property Value: Integer read FValue write FValue; 
  end;
  
constructor TMyAssoc.Create;
begin
  inherited Create;
  MagicClass := TMyAssoc;
end;

function TMyAssoc.GetItem(AName: Integer): TMyAssoc;
begin
  Result := TMyAssoc(inherited GetItem(IntToStr(AName)));
end;

procedure TMyAssoc.Print;
begin
  writeln(DoIndent(Level-1), Name, '.Value = ', Value:6, '  ', Name, '.Info = ', Info);
end;
// -------
  
var
  Tab: TMyAssoc;
  Item: TCustomAssocArray;
  
begin
  Tab := TMyAssoc.Create;
  
  Tab[1][2][3].Value := 123;
  Tab[1][2][1].Value := 234;
  Tab[1][2][2].Value := Tab[1][2][3].Value * 2;
  Tab[1].Value := 333;
  
  Tab[1][2][1].Info := 'Info1';
  Tab[1][2][2].Info := 'Info2';
  Tab[1][2][3].Info := 'Info3';
  
  Tab[2].Info := 'smth';
  
  Item := nil;
  while Tab.ForEachLevel(Item) do
  begin
    TMyAssoc(Item).Print;
  end;
  
  Tab.Free;
end.
