program test;

uses
  assoca, sysutils {tylko dla IntToStr()};

var
  Tab: TAssocStr;
  Item: TAssocStr;
  
  // zmienne potrzebne do wypelnienia tablicy ;]
  I, J, K: Integer;

begin
  Tab := TAssocStr.Create;

  // wypelnienie tablicy
  for I := 1 to 10 do
    for J := 1 to 5 do
      for K := 1 to 3 do
      begin
        Tab['Item'+IntToStr(I)]['SubItem'+IntToStr(J)]['SubSubItem'+IntToStr(K)].Value := IntToStr(I*J*K);
      end;
      
  // dodanie paru pozycji 'nie z automatu' ;)
  Tab['Cos'].Value := 'Cos1';
  Tab['Cos']['A'].Value := 'Cos2';  
  Tab['Cos']['A']['B'].Value := 'Cos3';

  // ForEach
  WriteLn('Zastosowanie funkcji ForEach [tylko jeden wymiar]:');
  Item := nil; // przy nil startuje od pierwszego elementu
  while Tab.ForEach(Item) do
  begin
    write('  Name=', Item.Name);
    if Item.Value <> '' then write(', Value=', Item.Value);
    WriteLn;
  end;
  
  // ForEach 2
  WriteLn('Zastosowanie funkcji ForEach [zaczynamy od innego polozenia]:');
  Item := Tab['Item2']['SubItem1']; // przy podaniu itemu, startuje od NASTEPNEGO (.Next)
  while Tab.ForEach(Item) do
  begin
    write('  Name=', Item.Name);
    if Item.Value <> '' then write(', Value=', Item.Value);
    WriteLn;
  end;  

  // ForEachLevel
  WriteLn('Zastosowanie funkcji ForEachLevel [wszystkie wymiary]:');  
  Item := nil;
  while Tab.ForEachLevel(Item) do
  begin
    write(DoIndent(Item.Level-1));
    if Item.HaveChilds then write('+ ') else write('- '); // + jesli ma dzieci, - jesli nie ma... stworzy cos w stylu listy rozwijanej
    write('Name=', Item.name);
    if Item.Value <> '' then write(', Value=', Item.Value);
    WriteLn;
  end;

  // Length zwraca ilosc dzieci, dzieci-dzieci itd + 1 (czyli parent)  
  writeln('] .Length');
  writeln('Tab.Length=', Tab.Length, '(', 10*5*3{SubSubItemy} + 10*5{SubItemy} + 10{Itemy} + 1{Tab}, ')');
  writeln('Tab[Item2][SubItem4].Length=', Tab['Item2']['SubItem4'].Length);
  
  // Rank zawiera liczbe wymiarow
  writeln('] .Rank');
  writeln('Tab.Rank=', Tab.Rank);
  writeln('Tab[Item4].Rank=', Tab['Item4'].Rank);
  writeln('Tab[Item6][SubItem2].Rank=', Tab['Item6']['SubItem2'].Rank);
  writeln('Tab[Item8][SubItem4][SubSubItem2].Rank=', Tab['Item8']['SubItem4']['SubSubItem2'].Rank);
  
  // ChildCount zawiera liczbe elementow w danym wymiarze
  writeln('] .ChildCount');
  writeln('Tab.ChildCount=', Tab.ChildCount);
  writeln('Tab[Item10].ChildCount=', Tab['Item10'].ChildCount);
  writeln('Tab[Item10][SubItem1].ChildCount=', Tab['Item10']['SubItem1'].ChildCount);
  writeln('Tab[Item10][SubItem1][SubSubItem1].ChildCount=', Tab['Item10']['SubItem1']['SubSubItem1'].ChildCount);
  
  Tab.Free; // uzycie .Free zwalnia wszelkie pozycje tablicy..
end.
